diff --git a/Units/parser-ada.r/ada-overriding.d/args.ctags b/Units/parser-ada.r/ada-overriding.d/args.ctags
new file mode 100644
index 0000000000..5ee5f79f70
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/args.ctags
@@ -0,0 +1 @@
+--sort=no
diff --git a/Units/parser-ada.r/ada-overriding.d/expected.tags b/Units/parser-ada.r/ada-overriding.d/expected.tags
new file mode 100644
index 0000000000..e69de29bb2
diff --git a/Units/parser-ada.r/ada-overriding.d/input-2.ada b/Units/parser-ada.r/ada-overriding.d/input-2.ada
new file mode 100644
index 0000000000..965d3c943c
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/input-2.ada
@@ -0,0 +1,36 @@
+--  Taken from #2382 submitted by @JulienPivard
+with Ada.Text_IO;
+
+package body Carte_P.Tasche_P
+   with Spark_Mode => Off
+is
+
+   ---------------------------------------------------------------------------
+   task body Tasche_T is
+      --  Les déclarations qui vont bien.
+   begin
+      accept Coucou do
+         null;
+      end Coucou;
+
+      Ada.Text_IO.Put_Line (Item => "Wesh gros je suis une tâche");
+
+      --  accept Inutile do
+      --     null;
+      --  end Inutile;
+      abort Tasche_T;
+   end Tasche_T;
+   ---------------------------------------------------------------------------
+
+   ---------------------------------------------------------------------------
+   overriding
+   procedure Inutile
+      (This : in out Tasche_T)
+   is
+   begin
+      null;
+   end Inutile;
+   ---------------------------------------------------------------------------
+
+end Carte_P.Tasche_P;
+
diff --git a/Units/parser-ada.r/ada-overriding.d/input.ada b/Units/parser-ada.r/ada-overriding.d/input.ada
new file mode 100644
index 0000000000..267ddd2902
--- /dev/null
+++ b/Units/parser-ada.r/ada-overriding.d/input.ada
@@ -0,0 +1,40 @@
+--  Taken from #2382 submitted by @JulienPivard
+--  @summary
+--  Implémentation par une tâche.
+--  @description
+--  Implémentation par une tache de la classe synchronisé.
+--  @group Version tâche
+package Carte_P.Tasche_P
+   with
+      Pure           => False,
+      Preelaborate   => False,
+      Elaborate_Body => True,
+      Spark_Mode     => Off
+is
+
+   ---------------------------------------------------------------------------
+   task type Tasche_T is new Carte_T with
+   --  Implémentation par une tâche de l'interface Carte_T.
+
+      -----------------------------------
+      overriding
+      entry Coucou;
+      --  Implémentation par un accept.
+
+      -----------------------------------
+      --  overriding
+      --  entry Inutile;
+      --  Implémentation par un accept.
+      --  @param This
+      --  La carte.
+   end Tasche_T;
+   ---------------------------------------------------------------------------
+
+   overriding
+   procedure Inutile
+      (This : in out Tasche_T);
+   --  Implémentation par une procédure.
+   --  @param This
+   --  La carte.
+
+end Carte_P.Tasche_P;
diff --git a/parsers/ada.c b/parsers/ada.c
index bbd6792af8..9c4e0b4381 100644
--- a/parsers/ada.c
+++ b/parsers/ada.c
@@ -228,6 +228,7 @@ typedef enum eAdaKeywords
   ADA_KEYWORD_LOOP,
   ADA_KEYWORD_NEW,
   ADA_KEYWORD_OR,
+  ADA_KEYWORD_OVERRIDING,		/* Ada 2005 */
   ADA_KEYWORD_PACKAGE,
   ADA_KEYWORD_PRAGMA,
   ADA_KEYWORD_PRIVATE,
@@ -271,6 +272,7 @@ static const char *AdaKeywords[] =
   "loop",
   "new",
   "or",
+  "overriding",
   "package",
   "pragma",
   "private",
@@ -1515,6 +1517,11 @@ static adaTokenInfo *adaParse(adaParseMode mode, adaTokenInfo *parent)
             skipPast(";");
           }
         } /* else if(adaKeywordCmp(ADA_KEYWORD_SEPARATE)) */
+		else if (adaKeywordCmp(ADA_KEYWORD_OVERRIDING))
+		{
+			/* Do nothing, just ignore this keyword. */
+			;
+		}
         else
         {
           /* otherwise, nothing was found so just skip until the end of this
@@ -1723,6 +1730,11 @@ static adaTokenInfo *adaParse(adaParseMode mode, adaTokenInfo *parent)
 
           skipWhiteSpace();
         }
+		else if (adaKeywordCmp(ADA_KEYWORD_OVERRIDING))
+		{
+			/* Do nothing, just ignore this keyword. */
+			;
+		}
         else
         {
           /* if nothing else matched this is probably a variable, constant
